<?php

namespace App\modele;

use App\gateway\AlumniGateway;
use App\gateway\Connection;
use App\gateway\ImageGateway;
use App\gateway\OffreGateway;
use App\metier\Alumni;
use App\metier\Offre;
use App\metier\Image;

class OffreModele
{

    private OffreGateway $offreGw;

    public function __construct()
    {
        $this->offreGw = new OffreGateway(new Connection("mysql:host=localhost;dbname=dbAlica", "test", "test"));
    }

    public function publierOffre(Image $img)
    {

        $desc = $_POST["description"];
        $descposte = $_POST["descriptPoste"];
        $nom = $_POST["name"];
        $ville = $_POST["ville"];
        $entreprise = $_POST["entreprise"];
        $profilRecherche = $_POST["profilRecherche"];
        $mail = $_POST["mail"];
        $num = $_POST["num"];
        $site = $_POST["site"];
        $exp = $_POST["choixExp"];

        $typeContrat = $_POST["typeContrat"];
    /*    $typeContrat = match ($_POST["typeContrat"]) {
            "Stage" => TypeContrat::Stage,
            "CDI" => TypeContrat::CDI,
            "CDD" => TypeContrat::CDD,
            "Alternance" => TypeContrat::Alternance,
            default => TypeContrat::CDD,
        };*/

        $niveauEtudes = $_POST["education"];
       /* $niveauEtudes = match ($_POST["education"]) {
            "Bac+2" => NiveauEtudes::Bac2,
            "Bac+3" => NiveauEtudes::Bac3,
            "Bac+5" => NiveauEtudes::Bac5,
            default => NiveauEtudes::Indifferent,
        };*/

        if(isset($_POST["fullRemote"]))
        {
           $remote = true;
        }
        else {
            $remote = false;
        }
        // à la place de NULL passer id utilisateur créateur offre
        $offre = new Offre($this->offreGw->getMaxid(),
            new Alumni(12,"test.mail@icloud.fr","password","admin"),
            $nom,
            $desc,
            $img,
            $typeContrat,
            $ville,
            $entreprise,
            $descposte,
            $profilRecherche,
            $exp,
            $niveauEtudes,
            $mail,
            $num,
            $site,
            $remote);
            $this->offreGw->ajouterOffre($offre);

    }
    public function obtenirOffres() : array
    {
        $alGw = new AlumniGateway(new Connection("mysql:host=localhost;dbname=dbAlica", "test", "test"));
        $imgGw = new ImageGateway(new Connection("mysql:host=localhost;dbname=dbAlica", "test", "test"));
        $res = $this->offreGw->obtenirOffres();
        $offres=[];

        foreach ($res as $row)
        {
            $res = $imgGw->obtenirParId($row['image']);
            $img = new Image(intval($res[0]["id"]),$res[0]['nom'], $res[0]['taille'], $res[0]['type'], $res[0]['blob']);

            $resal = $alGw->findById($row['offreur']);
            $alumni = new Alumni($resal[0]['id'],$resal[0]['mail'],$resal[0]['mdp'],$resal[0]['role']);

            $offres[]= new Offre($row['id'],
            $alumni,
            $row['titre'],
            $row['description'],
            $img,
            $row['typeContrat'],
            $row['ville'],
            $row["entreprise"],
            $row['descriptifPoste'],
            $row['profil'],
            $row['experience'],
            $row['niveauEtudes'],
            $row['mailContact'],
            $row['numero'],
            $row['websiteURL'],
            $row['remote']);
        }

        return $offres;
    }



}