// change la possibilité d'entrer une ville pour l'offre
// cas où l'offre est à pourvoir en full remote
document.getElementById("fullRemote").addEventListener("change", function () {
    var villeInput = document.getElementById("ville");
    villeInput.disabled = this.checked;
    //var ville = document.getElementById('')
});

document.addEventListener("DOMContentLoaded", function() {
    const form = document.querySelector("form");
    const submitButton = document.querySelector('input[type="submit"]');

    // Fonction pour vérifier si tous les champs du formulaire sont remplis
    function checkFormFields() {
        const inputs = form.querySelectorAll('input, textarea, select');
        let allFieldsFilled = true;

        inputs.forEach(function(input) {
            if (!input.value) {
                allFieldsFilled = false;
            }
        });

        submitButton.disabled = !allFieldsFilled;
    }

    // Écoute les événements de saisie dans les champs du formulaire
    form.addEventListener("input", checkFormFields);

    // Appelle la fonction initiale pour la première vérification
    checkFormFields();
});