<?php
namespace App\modele;
use App\metier\Alumni;
use App\metier\Evenement;
use App\metier\Image;

class UtilisateurModele

{
    /**
     * @description Charger le flux d'activiter
     * @return array flux
     */
    public function LoadFeed() : array
    {
        // TO DO
        return [];
    }

    /**
     * @description se connecter
     * @param string email
     * @param string hash
     * @return \App\metier\Alumni
     */
    // public function Login(string $email,string $hash) : \App\metier\Alumni
    // {
    //     // TO DO
    //     return new \App\metier\Alumni(null,null,null);
    // }

    /**
     * @description s'inscrire
     * @param string email
     * @param string hash
     * @param string $pseudo
     * @return \Alumni chargé
     */
    // public function inscription(string $email, string $hashpassword): \App\metier\Alumni
    // {
    //     $dsn = "mysql:host=localhost;dbname=dbAlica";
    //     $username = "test";
    //     $password = "test";

    //     $role = "Utilisateur";
    //     $con = new \App\gateway\Connection($dsn, $username, $password);
    //     $gate = new \App\gateway\AlumniGateway($con);
    //     // Insérez le nouvel utilisateur dans la base de données en utilisant AlumniGateway
    //     if ($gate->insert($email, $hashpassword, $role)) {
    //         // L'insertion a réussi, retournez le nouvel utilisateur
    //         $nouvelUtilisateur = new \App\metier\Alumni($email, $hashpassword, $role);
    //         return $nouvelUtilisateur;
    //     } else {
    //         // L'insertion a échoué, renvoyez un utilisateur vide pour indiquer l'échec
    //         return new \App\metier\Alumni(null, null,  null);
    //     }
    // }

    public function getEvenement() : array 
    {
        $dsn = "mysql:host=localhost;dbname=dbAlica";
        $login = "test";
        $mdp = "test";
 
        $con = new \App\gateway\Connection($dsn, $login, $mdp); 
        $gate = new \App\gateway\EvenementGateway($con); 
        $data = $gate->getAllEvenement();
        
        $gateAlumni = new \App\gateway\AlumniGateway($con);
        $dataAlumni = $gateAlumni->findById($data[0]['organisateur']);

        $gateImage = new \App\gateway\ImageGateway($con);
        $image = $gateImage->obtenirParId($data[0]['image']);

        $organisateur = new \App\metier\Alumni(
            $dataAlumni[0]['id'],
            $dataAlumni[0]['mail'],
            $dataAlumni[0]['mdp'],
            $dataAlumni[0]['role']
        );

        $img = new \App\metier\Image(
            $image[0]['id'],
            $image[0]['nom'],
            $image[0]['taille'],
            $image[0]['type'],
            $image[0]['blob']
        );

        foreach($data as $row)
        {
            $evenement[] = new \App\metier\Evenement(
                $row['id'],
                $organisateur,
                $row['titre'],
                $row['description'],
                $row['date'],
                $row['nbPlaceMax'],
                $img
            );
        }
        return $evenement;
    }

    public function ajouterEvenement(Image $img)
    {
        $dsn = "mysql:host=localhost;dbname=dbAlica";
        $login = "test";
        $mdp = "test";

        echo "test";

        $con = new \App\gateway\Connection($dsn, $login, $mdp);
        $gate = new \App\gateway\EvenementGateway($con);

        $titre = $_POST["titre"];
        $description = $_POST["description"];
        $date = $_POST["date"];
        $nbPlaceMax = $_POST["nbPlaceMax"];
        $img = $_POST["image"];

        $evenement = new Evenement(
            1,
            new Alumni(12,"test.mail@icloud.fr","password","admin"),
            $titre,
            $description,
            $date,
            $nbPlaceMax,
            $img
        );

        $gate->insertEvenement($evenement);
    }
}